// Merge sort using a queue of lists

import scala.compat.Platform.currentTime

private class Node(val el: List[Int], var next: Node)
class Queue {
  private var front: Node = null
  private var rear: Node = null
  def enqueue(el: List[Int]) {
    if (rear == null) {
      front = new Node(el, null)
      rear = front
    } else {
      rear.next = new Node(el, null)
      rear = rear.next
    }
  }
  def dequeue(): List[Int] = {
    val el = front.el
    front = front.next
    if (front == null)
      rear = null
    el
  }
}

def merge(L1: List[Int], L2: List[Int]): List[Int] = {
  val L = new scala.collection.mutable.ListBuffer[Int]
  var A = L1
  var B = L2
  while (A.nonEmpty && B.nonEmpty) {
    if (A.head < B.head) {
      L += A.head
      A = A.tail
    } else {
      L += B.head
      B = B.tail
    }
  }
  L ++= A
  L ++= B
  L.toList
}

def mergeSort(L: List[Int]): List[Int] = {
  val q = new Queue
  for (el <- L)
    q.enqueue(List(el))
  val n = L.length
  for (i <- 1 to n-1) {
    val m = merge(q.dequeue(), q.dequeue())
    q.enqueue(m)
  }
  q.dequeue()
}

var L: List[Int] = Nil
for (i <- 1 to 1000000)
  L = (math.random * 10000000).toInt :: L
println(L take 30)
val t0 = currentTime
val S = mergeSort(L)
val t1 = currentTime
println(S take 30)
printf("Sorting %d numbers took %d milliseconds\n", L.length, t1 - t0)
