// Section sort for lists

def select(L: List[Int]): (Int, List[Int]) = {
  L match {
    case List(x) => (x, Nil)
    case x :: xs => 
      val (y, ys) = select(xs)
      if (x < y) 
	(x, xs)
      else
	(y, x :: ys)
  }
}

def selectionSort(L:List[Int]): List[Int] = {
  if (L.isEmpty)
    Nil
  else {
    val (x, xs) = select(L)
    x :: selectionSort(xs)
  }
}

var L: List[Int] = Nil
for (i <- 1 to 100)
  L = (math.random * 1000).toInt :: L
println(L)
val S = selectionSort(L)
println(S)
